"""Summoner

This file acts as a bridge between invoke tasks and the various
functions we want to execute with it. The goal here is to keep
this file as clean as possible and it simply dispatches requests
out to seperate files.

"""

def type_convert(item):
    """
    This is a helper function to convert strings into
    a native boolean type.  For example "False" should be
    turned into a False boolean.
    """
    if isinstance(item, str):
        if item.lower() == "True".lower():
            return True
        if item.lower() == "False".lower():
            return False

        return item
    return item

def param_helper(args, kwargs):
    """
    This is a silly function required by invoke so we can pass
    arbitrary args and kwargs to our real summoner functions.

    We parse the provided parameters and return a list and a dictionary
    based on the strings we are provided. This is ugly, but invoke doesn't
    give us a choice here. Probably should just switch to argparse.
    https://github.com/pyinvoke/invoke/issues/378
    """
    return_args = []
    if args != "":
        for arg in args.split(','):
            return_args.append(type_convert(arg))

    if kwargs == "":
        return_kwargs = {}
    else:
        return_kwargs = dict()
        for kwarg in kwargs.split(','):
            key, value = kwarg.split('=')
            value = type_convert(value)
            return_kwargs[key] = value

    return (return_args, return_kwargs)
